/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/hardware/dynamixel-genom3/work/templates/ros/client/ros/dynamixel_ros/msg/dynamixel_limits_s.msg
 *
 */


#ifndef DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_LIMITS_S_H
#define DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_LIMITS_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace dynamixel_ros
{
template <class ContainerAllocator>
struct dynamixel_limits_s_
{
  typedef dynamixel_limits_s_<ContainerAllocator> Type;

  dynamixel_limits_s_()
    : temperature_max(0.0)
    , voltage_min(0.0)
    , voltage_max(0.0)
    , pwm_max(0.0)
    , current_max(0.0)
    , acceleration_max(0.0)
    , velocity_max(0.0)  {
    }
  dynamixel_limits_s_(const ContainerAllocator& _alloc)
    : temperature_max(0.0)
    , voltage_min(0.0)
    , voltage_max(0.0)
    , pwm_max(0.0)
    , current_max(0.0)
    , acceleration_max(0.0)
    , velocity_max(0.0)  {
    }



   typedef double _temperature_max_type;
  _temperature_max_type temperature_max;

   typedef double _voltage_min_type;
  _voltage_min_type voltage_min;

   typedef double _voltage_max_type;
  _voltage_max_type voltage_max;

   typedef double _pwm_max_type;
  _pwm_max_type pwm_max;

   typedef double _current_max_type;
  _current_max_type current_max;

   typedef double _acceleration_max_type;
  _acceleration_max_type acceleration_max;

   typedef double _velocity_max_type;
  _velocity_max_type velocity_max;




  typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> const> ConstPtr;

}; // struct dynamixel_limits_s_

typedef ::dynamixel_ros::dynamixel_limits_s_<std::allocator<void> > dynamixel_limits_s;

typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_limits_s > dynamixel_limits_sPtr;
typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_limits_s const> dynamixel_limits_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dynamixel_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'dynamixel_ros': ['dynamixel_ros/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fc58a55f1319f586f88c7175aeb17e9e";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xfc58a55f1319f586ULL;
  static const uint64_t static_value2 = 0xf88c7175aeb17e9eULL;
};

template<class ContainerAllocator>
struct DataType< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dynamixel_ros/dynamixel_limits_s";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::dynamixel::limits_s\n\
float64 temperature_max\n\
float64 voltage_min\n\
float64 voltage_max\n\
float64 pwm_max\n\
float64 current_max\n\
float64 acceleration_max\n\
float64 velocity_max\n\
";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.temperature_max);
      stream.next(m.voltage_min);
      stream.next(m.voltage_max);
      stream.next(m.pwm_max);
      stream.next(m.current_max);
      stream.next(m.acceleration_max);
      stream.next(m.velocity_max);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct dynamixel_limits_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dynamixel_ros::dynamixel_limits_s_<ContainerAllocator>& v)
  {
    s << indent << "temperature_max: ";
    Printer<double>::stream(s, indent + "  ", v.temperature_max);
    s << indent << "voltage_min: ";
    Printer<double>::stream(s, indent + "  ", v.voltage_min);
    s << indent << "voltage_max: ";
    Printer<double>::stream(s, indent + "  ", v.voltage_max);
    s << indent << "pwm_max: ";
    Printer<double>::stream(s, indent + "  ", v.pwm_max);
    s << indent << "current_max: ";
    Printer<double>::stream(s, indent + "  ", v.current_max);
    s << indent << "acceleration_max: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration_max);
    s << indent << "velocity_max: ";
    Printer<double>::stream(s, indent + "  ", v.velocity_max);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_LIMITS_S_H
