/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/hardware/dynamixel-genom3/work/templates/ros/client/ros/dynamixel_ros/msg/dynamixel_profile_s.msg
 *
 */


#ifndef DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_PROFILE_S_H
#define DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_PROFILE_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace dynamixel_ros
{
template <class ContainerAllocator>
struct dynamixel_profile_s_
{
  typedef dynamixel_profile_s_<ContainerAllocator> Type;

  dynamixel_profile_s_()
    : velocity(0.0)
    , acceleration(0.0)  {
    }
  dynamixel_profile_s_(const ContainerAllocator& _alloc)
    : velocity(0.0)
    , acceleration(0.0)  {
    }



   typedef double _velocity_type;
  _velocity_type velocity;

   typedef double _acceleration_type;
  _acceleration_type acceleration;




  typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> const> ConstPtr;

}; // struct dynamixel_profile_s_

typedef ::dynamixel_ros::dynamixel_profile_s_<std::allocator<void> > dynamixel_profile_s;

typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_profile_s > dynamixel_profile_sPtr;
typedef boost::shared_ptr< ::dynamixel_ros::dynamixel_profile_s const> dynamixel_profile_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dynamixel_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'dynamixel_ros': ['dynamixel_ros/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "05e35dfbdcc7f2dbca9ec8c88fd48d16";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x05e35dfbdcc7f2dbULL;
  static const uint64_t static_value2 = 0xca9ec8c88fd48d16ULL;
};

template<class ContainerAllocator>
struct DataType< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dynamixel_ros/dynamixel_profile_s";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::dynamixel::profile_s\n\
float64 velocity\n\
float64 acceleration\n\
";
  }

  static const char* value(const ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.velocity);
      stream.next(m.acceleration);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct dynamixel_profile_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dynamixel_ros::dynamixel_profile_s_<ContainerAllocator>& v)
  {
    s << indent << "velocity: ";
    Printer<double>::stream(s, indent + "  ", v.velocity);
    s << indent << "acceleration: ";
    Printer<double>::stream(s, indent + "  ", v.acceleration);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DYNAMIXEL_ROS_MESSAGE_DYNAMIXEL_PROFILE_S_H
